part of navigine_sdk;

class NavigineSDK {
  Completer? _locationCompleter;
  Location? location;

  NavigineSDK.initializeSDK({
    required String userHash,
    String serverURL = "https://api.navigine.com",
  }) {
    _channel.invokeMethod('initialize', {
      "userHash": userHash,
      "serverUrl": serverURL,
    });
    _channel.setMethodCallHandler((call) async {
      switch (call.method) {
        case "location#onFailed":
          _locationCompleter?.completeError(
            Exception(
              "Unable to download the location. Error code: ${call.arguments}",
            ),
          );
          break;
        case "location#onFinished":
          _locationCompleter?.complete();
          break;
        case "deviceInfo#onUpdate":
        case "marketing#onNotification":
          location?._handleMethodCall(call);
          break;
      }
      return true;
    });
  }

  Future<Location> loadLocation({required int locationId}) async {
    _locationCompleter = Completer();
    _channel.invokeMethod("loadLocation", {
      "locationId": locationId,
    });
    await _locationCompleter!.future;
    location = Location.fromMap(await _channel.invokeMethod("getLocation"));
    return location!;
  }

  clearSDK() {
    _channel.setMethodCallHandler(null);
  }
}
