part of navigine_sdk;

class LocationPoint {
  int location = 0;
  int subLocation = 0;
  num x = 0.0;
  num y = 0.0;

  LocationPoint();

  LocationPoint.fromLocationPoint(LocationPoint p) {
    this.location = p.location;
    this.subLocation = p.subLocation;
    this.x = p.x;
    this.y = p.y;
  }

  LocationPoint.fromData(int _location, int _subLocation, num _x, num _y) {
    this.location = _location;
    this.subLocation = _subLocation;
    this.x = _x;
    this.y = _y;
  }

  static fromMap(data) {
    LocationPoint lp = LocationPoint();
    lp.location = data["location"];
    lp.subLocation = data["subLocation"];
    lp.x = data["x"];
    lp.y = data["y"];
    return lp;
  }

  bool isValid() {
    return this.location > 0 && this.subLocation > 0;
  }

  num distanceTo(LocationPoint p) {
    return this.isValid() &&
            this.location == p.location &&
            this.subLocation == p.subLocation
        ? PointF.length(this.x - p.x, this.y - p.y)
        : 0.0 / 0.0;
  }

  toMap() {
    return {
      "location": location,
      "subLocation": subLocation,
      "x": x,
      "y": y,
    };
  }
}
